/**
 * Created with IntelliJ IDEA.
 * User: aaronlin
 * Date: 2018/7/11
 * Time: 16:55
 */
import React, {Component} from 'react';

import {
    ScrollView,
    Platform,
} from 'react-native';

import PullToRefreshContainerV2 from '../pulltorefresh/PullToRefreshContainerV2';

/**
 * 下拉刷新 ScrollView
 */
export default class RefreshScrollView extends Component{

    /**
     *
     */
    _scrollY = 0;

    constructor(props){
        super(props);
    }

    /**
     *
     * @param event
     * @private
     */
    _onScroll = (e) => {
        this._scrollY = e.nativeEvent.contentOffset.y;

        const{ onScroll } = this.props;
        onScroll && onScroll(e);
    }

    /**
     *
     * @param evt
     * @param gestureState
     * @returns {boolean}
     * @private
     */
    _isReadyForPullStart = (evt, gestureState)=>{
        const { dx, dy } = gestureState;
        if(this._scrollY <= 0){
            return dy > 0;
        }
    }

    /**
     * 刷新结束
     */
    endRefreshing = () => {
        this.refs.pullToRefreshContainer && this.refs.pullToRefreshContainer.endRefreshing();
    }

    render(){
        const { pullContainerStyle, headerStyle, onRefresh, ...otherProps } = this.props;

        return(
            <PullToRefreshContainerV2
                ref={'pullToRefreshContainer'}
                isReadyForPullStart={this._isReadyForPullStart}
                style={[styles.container, pullContainerStyle]}
                headerStyle={[headerStyle]}
                onRefresh={onRefresh}
            >

                <ScrollView
                    {...otherProps}
                    onScroll={this._onScroll}
                />

            </PullToRefreshContainerV2>
        );
    }

}

const styles = {
    container: {
        flex: 1,
        backgroundColor: "#ffffff"
    }
};